Imports System.Collections
Imports Microsoft.Win32
Imports System.Runtime.InteropServices

''' <summary>
''' ^C][NX
''' </summary>
''' <remarks></remarks>
Friend Class TimeZone
    Private TimeZoneArray As ArrayList = Nothing
    Private TimeZoneNameArray As ArrayList = Nothing

    ' ݂Ă^C][擾vpeB
    Public ReadOnly Property TimeZoneNames() As ArrayList
        Get
            Return TimeZoneNameArray
        End Get
    End Property

    Public Sub New()
        TimeZoneArray = EnumTimeZoneInfo(TimeZoneNameArray)
    End Sub

    ''' <summary>
    ''' w肳ꂽ^C][̌ݓ擾
    ''' </summary>
    ''' <param name="strTimeZoneName">^C][</param>
    ''' <returns>w肳ꂽ^C][̌ݓ DateTime ^ŕԂ</returns>
    ''' <remarks></remarks>
    Public Function TzNowDateTime(ByVal strTimeZoneName As String) As System.DateTime
        ' OS Ɏw肳Ă^C][̌ݓ擾
        Dim dt As System.DateTime = DateTime.Now

        If strTimeZoneName <> "" Or strTimeZoneName <> Nothing Then

            ' ݎ DateTime  SYSTEMTIME ^ɕϊ
            Dim sysTime As Win32TimeAPI.SYSTEMTIME = DateTimeToSystemTime(DateTime.UtcNow)
            ' ^C][ TIME_ZONE_INFORMATION \̂擾
            Dim FindTZ As Win32TimeAPI.TIME_ZONE_INFORMATION = TimeZoneInfoStructureFromTimeZoneName(strTimeZoneName)

            Dim stLocal As Win32TimeAPI.SYSTEMTIME

            Try
                ' w肳ꂽ^C][̏ SYSTEMTIME \̂Ŏ擾
                Win32TimeAPI.SystemTimeToTzSpecificLocalTime(FindTZ, sysTime, stLocal)
                ' 擾 SYSTEMTIME \̂ DateTime ^ɕϊ
                Return SystemTimeToDateTime(stLocal)
            Catch ex As EntryPointNotFoundException
                Throw New NotSupportedException("SystemTimeToTzSpecificLocalTime() ́A OS ŃT|[gĂ܂B", ex)
            End Try
        End If
        Return dt
    End Function

    ''' <summary>
    '''  OS ɐݒ肳Ă^C][擾
    ''' </summary>
    ''' <returns>^C][Ԃ</returns>
    ''' <remarks></remarks>
    Public Function GetOsTimeZoneName() As String
        Dim strCurrentTZName As String = ""
        ' TIME_ZONE_INFORMATION 
        Dim tziCurrent As Win32TimeAPI.TIME_ZONE_INFORMATION = New Win32TimeAPI.TIME_ZONE_INFORMATION
        ' OS Ɏw肳Ă^C TIME_ZONE_INFORMATION \̂Ŏ擾
        Win32TimeAPI.GetTimeZoneInformation(tziCurrent)
        ' TIME_ZONE_INFORMATION \̂^C][
        For Each timeZoneInfo2 As TimeZoneInfo In TimeZoneArray
            If timeZoneInfo2.TimeZoneInfoStruct.Bias = tziCurrent.Bias And _
                timeZoneInfo2.TimeZoneInfoStruct.DaylightBias = tziCurrent.DaylightBias And _
                timeZoneInfo2.TimeZoneInfoStruct.DaylightName = tziCurrent.DaylightName Or _
                timeZoneInfo2.TimeZoneInfoStruct.StandardBias = tziCurrent.StandardBias And _
                timeZoneInfo2.TimeZoneInfoStruct.StandardName = tziCurrent.StandardName Then
                strCurrentTZName = timeZoneInfo2.strDisplayName
                Return strCurrentTZName
            End If
        Next
        Return strCurrentTZName
    End Function

    ''' <summary>
    ''' DateTime ^ SYSTEMTIME \̂ɕϊ
    ''' </summary>
    ''' <param name="dt">DateTime lw</param>
    ''' <returns>SYSTEMTIME \̂Ԃ</returns>
    ''' <remarks></remarks>
    Private Shared Function DateTimeToSystemTime(ByVal dt As DateTime) As Win32TimeAPI.SYSTEMTIME
        Dim st As Win32TimeAPI.SYSTEMTIME
        Dim ft As ComTypes.FILETIME = New ComTypes.FILETIME()

        ft.dwHighDateTime = HWORD(dt.Ticks)
        ft.dwLowDateTime = LWORD(dt.Ticks)

        Win32TimeAPI.FileTimeToSystemTime(ft, st)

        Return st
    End Function

    ''' <summary>
    ''' SYSTEMTIME \̂DateTime ^ɕϊ
    ''' </summary>
    ''' <param name="st">SYSTEMTIME \̂w</param>
    ''' <returns>DateTime lԂ</returns>
    ''' <remarks></remarks>
    Private Shared Function SystemTimeToDateTime(ByRef st As Win32TimeAPI.SYSTEMTIME) As DateTime
        Dim ft As ComTypes.FILETIME = New ComTypes.FILETIME()

        Win32TimeAPI.SystemTimeToFileTime(st, ft)

        Dim dt As DateTime = New DateTime(GetLong(ft.dwHighDateTime, ft.dwLowDateTime))
        Return dt
    End Function

    ''' <summary>
    ''' ʃrbg擾
    ''' </summary>
    ''' <param name="LongValue"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Shared Function HWORD(ByVal LongValue As Long) As Integer
        'ʂZo
        HWORD = (LongValue And &HFFFFFFFF00000000) \ &H100000000
    End Function

    ''' <summary>
    ''' ʃrbg擾
    ''' </summary>
    ''' <param name="LongValue"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Shared Function LWORD(ByVal LongValue As Long) As Integer
        'ʃrbgZo
        If (LongValue And &HFFFFFFFF&) > &H7FFFFFFF Then
            LWORD = (LongValue And &HFFFFFFFF&) - &H100000000
        Else
            LWORD = LongValue And &HFFFFFFFF&
        End If
    End Function

    ''' <summary>
    ''' w肳ꂽ232rbglA
    ''' </summary>
    ''' <param name="UpperWord"></param>
    ''' <param name="LowerWord"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Shared Function GetLong(ByVal UpperWord As Integer, ByVal LowerWord As Integer) As Long
        'ʁEʂAĒl(64rbgl)擾
        GetLong = (LowerWord And &HFFFFFFFF&) Or (UpperWord * &H100000000)
    End Function

    ''' <summary>
    ''' ^C][TIME_ZONE_INFORMATION\̏擾
    ''' </summary>
    ''' <param name="strTimeZoneName">^C][</param>
    ''' <returns>TIME_ZONE_INFORMATION\̒lԂ</returns>
    ''' <remarks></remarks>
    Function TimeZoneInfoStructureFromTimeZoneName(ByVal strTimeZoneName As String) As Win32TimeAPI.TIME_ZONE_INFORMATION

        For Each tz As TimeZoneInfo In TimeZoneArray
            If tz.strDisplayName = strTimeZoneName Then
                Return tz.TimeZoneInfoStruct
            End If
        Next
        Return Nothing
    End Function

    ''' <summary>
    ''' OS ɓo^Ă^C][Sė
    ''' </summary>
    ''' <returns>Win32TimeAPI.TIME_ZONE_INFORMATION i[ ArrayList ԂB</returns>
    ''' <remarks></remarks>
    Private Function EnumTimeZoneInfo(ByRef timeZoneName As ArrayList) As ArrayList
        Dim TimeZoneArray As ArrayList = New ArrayList()
        timeZoneName = New ArrayList()
        ' ^C][񂪊i[ꂽWXgQ
        Using key As RegistryKey = Registry.LocalMachine.OpenSubKey( _
                "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Time Zones")
            ' WXg̃TuL[SĎ擾
            Dim strZoneNames() As String = key.GetSubKeyNames()

            ' SẴ^C][擾
            For Each strZoneName As String In strZoneNames
                Using subKey As RegistryKey = key.OpenSubKey(strZoneName)
                    Dim timeZoneInfo As TimeZoneInfo = New TimeZoneInfo()
                    Dim structTimeZoneInfo As Win32TimeAPI.TIME_ZONE_INFORMATION = New Win32TimeAPI.TIME_ZONE_INFORMATION()
                    ' WXgl^C][擾
                    timeZoneInfo.strDisplayName = CType(subKey.GetValue("Display"), String)
                    'timeZoneName.Add(timeZoneInfo.strDisplayName)
                    structTimeZoneInfo.DaylightName = CType(subKey.GetValue("Dlt"), String)
                    structTimeZoneInfo.StandardName = CType(subKey.GetValue("Std"), String)

                    ' WXg "Tzi" ̃oCi TZI \̂Ƀ}bsO
                    Dim byteInfo() As Byte = CType(subKey.GetValue("Tzi"), Byte())
                    Dim gcH As GCHandle = GCHandle.Alloc(byteInfo, GCHandleType.Pinned)
                    Dim structTZI As Win32TimeAPI.TZI = New Win32TimeAPI.TZI
                    Try
                        structTZI = CType(Marshal.PtrToStructure(gcH.AddrOfPinnedObject(), GetType(Win32TimeAPI.TZI)), Win32TimeAPI.TZI)
                    Finally
                        gcH.Free()
                    End Try
                    ' TZI \̂̏ TIME_ZONE_INFORMATION ɑ
                    structTimeZoneInfo.Bias = structTZI.bias
                    structTimeZoneInfo.DaylightBias = structTZI.daylightBias
                    structTimeZoneInfo.DaylightDate = structTZI.daylightDate
                    structTimeZoneInfo.StandardBias = structTZI.standardBias
                    structTimeZoneInfo.StandardDate = structTZI.standardDate
                    timeZoneInfo.TimeZoneInfoStruct = structTimeZoneInfo
                    ' ArrayList  TimeZoneInfo IuWFNgǉ
                    TimeZoneArray.Add(timeZoneInfo)
                End Using
            Next
            ' 擾^C][z Bias lŃ\[g
            TimeZoneArray.Sort(New TimeZoneInfoComparer)
            ' timeZoneName lݒ
            For Each timeZoneInfo2 As TimeZoneInfo In TimeZoneArray
                timeZoneName.Add(timeZoneInfo2.strDisplayName)
            Next
        End Using
        Return TimeZoneArray
    End Function

End Class

''' <summary>
''' ^C][ Bias lŃ\[g邽߂ IComparer NX
''' </summary>
''' <remarks></remarks>
Friend Class TimeZoneInfoComparer
    Implements IComparer
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
        Implements IComparer.Compare
        Dim tzx As TimeZoneInfo, tzy As TimeZoneInfo

        tzx = CType(x, TimeZoneInfo)
        tzy = CType(y, TimeZoneInfo)

        If tzx Is Nothing Or tzy Is Nothing Then
            Throw New ArgumentException("p[^ Nothing A^w肳܂B")
        End If

        ' Bias lr
        Dim biasDifference As Integer = tzy.TimeZoneInfoStruct.Bias - tzx.TimeZoneInfoStruct.Bias

        If biasDifference = 0 Then
            Return tzx.strDisplayName.CompareTo(tzy.strDisplayName)
        Else
            Return biasDifference
        End If
    End Function
End Class


''' <summary>
''' ^C][i[NX
''' </summary>
''' <remarks></remarks>
Friend Class TimeZoneInfo
    Public strDisplayName As String = ""
    Public TimeZoneInfoStruct As Win32TimeAPI.TIME_ZONE_INFORMATION = Nothing
End Class


''' <summary>
''' ^C֌W Win32API 錾NX
''' </summary>
''' <remarks></remarks>
Friend Class Win32TimeAPI

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SYSTEMTIME
        Public wYear As UInt16
        Public wMonth As UInt16
        Public wDayOfWeek As UInt16
        Public wDay As UInt16
        Public wHour As UInt16
        Public wMinute As UInt16
        Public wSecond As UInt16
        Public wMilliseconds As UInt16
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure TZI
        Public bias As Int32
        Public standardBias As Int32
        Public daylightBias As Int32
        Public standardDate As SYSTEMTIME
        Public daylightDate As SYSTEMTIME
    End Structure

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
    Public Structure TIME_ZONE_INFORMATION
        <MarshalAs(UnmanagedType.I4)> _
        Public Bias As Int32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public StandardName As String
        Public StandardDate As SYSTEMTIME
        <MarshalAs(UnmanagedType.I4)> _
        Public StandardBias As Int32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public DaylightName As String
        Public DaylightDate As SYSTEMTIME
        <MarshalAs(UnmanagedType.I4)> _
        Public DaylightBias As Int32
    End Structure

    <DllImport("KERNEL32.dll")> _
    Public Shared Function SystemTimeToTzSpecificLocalTime(<[In]()> ByRef lpTimeZone As TIME_ZONE_INFORMATION, <[In]()> ByRef lpUniversalTime As SYSTEMTIME, <Out()> ByRef lpLocalTime As SYSTEMTIME) As Boolean
    End Function

    <DllImport("KERNEL32.dll")> _
    Public Shared Function GetTimeZoneInformation(<Out()> ByRef lpTimeZone As TIME_ZONE_INFORMATION) As System.UInt32
    End Function

    <DllImport("KERNEL32.dll", SetLastError:=True)> _
    Public Shared Function FileTimeToSystemTime(<[In]()> ByRef lpFileTime As ComTypes.FILETIME, <Out()> ByRef lpSystemTime As SYSTEMTIME) As Boolean
    End Function

    <DllImport("kernel32.dll", SetLastError:=True)> _
    Public Shared Function SystemTimeToFileTime(<[In]()> ByRef lpSystemTime As SYSTEMTIME, <Out()> ByRef lpFileTime As ComTypes.FILETIME) As Integer
    End Function

End Class
